/*Copyright [2010] [David Van de Ven]

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.

 */

package org.wahtod.wififixer;

import android.app.AlarmManager;
import android.app.PendingIntent;
import android.content.Context;
import android.content.Intent;
import android.os.SystemClock;

public final class ServiceAlarm extends Object {
    public static final long PERIOD = 300000;
    public static final long STARTDELAY = 120000;
    private static final long NODELAY = 0;
    private static final String STARTINTENT = "org.wahtod.wififixer.WifiFixerService";
    public static final String ALARM = "ALARM";

    public static void setAlarm(Context c, boolean initialdelay) {
	Long delay;
	if (initialdelay)
	    delay = PERIOD;
	else
	    delay = NODELAY;

	Intent myStarterIntent = new Intent(STARTINTENT);
	myStarterIntent.setFlags(Intent.FLAG_FROM_BACKGROUND);
	myStarterIntent.putExtra(ALARM, true);
	AlarmManager mgr = (AlarmManager) c
		.getSystemService(Context.ALARM_SERVICE);
	PendingIntent pendingintent = PendingIntent.getService(c, 0,
		myStarterIntent, 0);

	mgr.setRepeating(AlarmManager.ELAPSED_REALTIME_WAKEUP, SystemClock
		.elapsedRealtime()
		+ delay, PERIOD, pendingintent);
    }

    public static void unsetAlarm(Context c) {
	Intent myStarterIntent = new Intent(c, WifiFixerService.class);
	myStarterIntent.setFlags(Intent.FLAG_FROM_BACKGROUND);
	AlarmManager mgr = (AlarmManager) c
		.getSystemService(Context.ALARM_SERVICE);
	PendingIntent pendingintent = PendingIntent.getService(c, 0,
		myStarterIntent, 0);

	mgr.cancel(pendingintent);
    }
}
